exercises/relations/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :tasks
  # BEGIN
  resources :users
  resources :statuses
  # END
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'home#index'
end

exercises/relations/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/relations/app/models/status.rb
# frozen_string_literal: true

class Status < ApplicationRecord
  # BEGIN
  has_many :tasks, dependent: :destroy
  # END
end

exercises/relations/app/models/task.rb
class Task < ApplicationRecord
  belongs_to :user
  belongs_to :status
end

exercises/relations/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  # BEGIN
  has_many :tasks, dependent: :destroy
  # END
end

exercises/relations/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/relations/app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

exercises/relations/app/controllers/statuses_controller.rb
# frozen_string_literal: true

class StatusesController < ApplicationController
  before_action :set_status, only: %i[show edit update destroy]

  def index
    @statuses = Status.all
  end

  def show; end

  def new
    @status = Status.new
  end

  def edit; end

  def create
    @status = Status.new(status_params)

    if @status.save
      redirect_to @status, notice: 'Status was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @status.update(status_params)
      redirect_to @status, notice: 'Status was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @status.destroy

    redirect_to statuses_url, notice: 'Status was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_status
    @status = Status.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def status_params
    params.require(:status).permit(:name)
  end
end

exercises/relations/app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: %i[ show edit update destroy ]

  # GET /tasks
  def index
    @tasks = Task.includes(:user, :status)
  end

  # GET /tasks/1
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: "Task was successfully created." }
      else
        format.html { render :new, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: "Task was successfully updated." }
      else
        format.html { render :edit, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: "Task was successfully destroyed." }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def task_params
      params.require(:task).permit(:name, :description, :user_id, :status_id)
    end
end

exercises/relations/app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  before_action :set_user, only: %i[show edit update destroy]

  def index
    @users = User.all
  end

  def show
    user = User.find params[:id]

    @tasks = user.tasks
  end

  def new
    @user = User.new
  end

  def edit; end

  def create
    @user = User.new(user_params)

    if @user.save
      redirect_to @user, notice: 'User was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @user.update(user_params)
      redirect_to @user, notice: 'User was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @user.destroy

    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_user
    @user = User.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def user_params
    params.require(:user).permit(:name)
  end
end

exercises/relations/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/relations/app/helpers/tasks_helper.rb
module TasksHelper
end

exercises/relations/app/views/tasks/_form.html.slim
= simple_form_for(@task) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :name
  = f.input :description
  = f.association :status, prompt: 'select status'
  = f.association :user, prompt: 'select user'

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/relations/app/views/tasks/edit.html.slim
h1 Editing task

== render 'form'

=> link_to 'Show', @task
'|
=< link_to 'Back', tasks_path

exercises/relations/app/views/tasks/index.html.slim
h1 Listing tasks

table
  thead
    tr
      th Name
      th Description
      th User
      th Status

  tbody
    - @tasks.each do |task|
      tr
        td = task.name
        td = task.description
        td = task.user.name
        td = task.status.name
        td = link_to 'Show', task
        td = link_to 'Edit', edit_task_path(task)
        td = link_to 'Destroy', task, data: { confirm: 'Are you sure?' }, method: :delete

br

= link_to 'New Task', new_task_path

exercises/relations/app/views/tasks/new.html.slim
h1 New task

== render 'form'

= link_to 'Back', tasks_path

exercises/relations/app/views/tasks/show.html.slim
p#notice = notice

p
  strong Name:
  = @task.name

p
  strong Description:
  = @task.description

=> link_to 'Edit', edit_task_path(@task)
'|
=< link_to 'Back', tasks_path